/**
  General-Purpose Graphics Processing Unit (GPGPU)
  Demo Application
  
  Orion Sky Lawlor, olawlor@acm.org, 2008-04-21 (Public Domain)
*/
#include "ogl/gpgpu.h" /* Orion's GPGPU library */
#include "ogl/glsl.cpp" /* for easy linking, just #include the library code */

int main(int argc,char *argv[]) {
	gpgpu_init();
	
	/* Make an output texture */
	static gpgpu_texture2D *tex=new gpgpu_texture2D(1024,1024);
	
	/* Make a GPU program to fill the texture with data. 
	  The program's return value is a color--
	*/
	static GLhandleARB prog=makeProgramObject(GPGPU_V,
		"varying vec4 location; /* onscreen location */\n"
		"void main(void) {\n"
		"	gl_FragColor = sin(location*6.28);\n"
		"}\n"
	);
	
	/* Execute the program into the texture, using a framebuffer */
	static gpgpu_framebuffer *fb=new gpgpu_framebuffer(tex);
	fb->run_time(prog);
	
	/* Show the resulting texture values */
	gpgpu_show_and_pause(tex,"GPGPU, Baby!");
	
	return 0;
}
