/**
  General-Purpose Graphics Processing Unit (GPGPU)
  Demo Application
  
  Orion Sky Lawlor, olawlor@acm.org, 2008-04-21 (Public Domain)
*/
#include "ogl/gpgpu.h" /* Orion's GPGPU library */
#include "ogl/glsl.cpp" /* for easy linking, just #include the library code */

int main(int argc,char *argv[]) {

	gpgpu_init();
	
	/* Upload a small texture for rendering */
	const static float my_colors[4*3*2]={
	/* floats are R,G,B,A colors for each pixel: 3 pixels wide, 2 pixels high */
		1,0,0,0,   0,1,0,0,  0,0,1,0,
		0,0,0,0,   1,1,1,1,  0.5,0.5,0.5,0
	};
	static gpgpu_texture2D *tex=new gpgpu_texture2D(3,2,my_colors);
	
	/* Read back the first pixel of the texture, using a framebuffer */
	float data[4];
	static gpgpu_framebuffer *fb=new gpgpu_framebuffer(tex);
	fb->read(data,1,1);
	std::cout<<"Read back floating-point data: "<<
		data[0]<<", "<<data[1]<<", "<<data[2]<<", "<<data[3]<<"\n";
	
	return 0;
}
