/**
  General-Purpose Graphics Processing Unit (GPGPU)
  Demo Application
  
  Orion Sky Lawlor, olawlor@acm.org, 2008-04-21 (Public Domain)
*/
#include "ogl/gpgpu.h" /* Orion's GPGPU library */
#include "ogl/glsl.cpp" /* for easy linking, just #include the library code */

int main(int argc,char *argv[]) {

	gpgpu_init();
	
	/* Upload a small texture for rendering */
	const static float my_colors[4*3*2]={
	/* floats are R,G,B,A colors for each pixel: 3 wide, 2 high */
		1,0,0,0,   0,1,0,0,  0,0,1,0,
		0,0,0,0,   1,1,1,1,  0.5,0.5,0.5,0
	};
	/* Subtle: the last argument is GL_RGBA8, because some cards don't
	   support linear filtering on floating-point textures... */
	static gpgpu_texture2D *tex=new gpgpu_texture2D(3,2,my_colors,GL_RGBA8);
	
	/* Show the texture as it's created by default */
	gpgpu_show_and_pause(tex,"Original Texture");
	
	tex->filter(GL_LINEAR);
	
	/* Show the texture with the new filtering mode */
	gpgpu_show_and_pause(tex,"Linear Filtering");

	return 0;
}
